/*
 * cpu.c
 *
 *  Created on: May 11, 2012
 *      Author: Mighty Moose
 */

#include "os.h"
#include "chip8.h"
#include "cpu.h"

inline void setPixel(int x, int y, int color)
{
  unsigned char* p = (unsigned char*)(SCREEN_BASE_ADDRESS + ((x >> 1) + (y << 7) + (y << 5)));
  *p = (x & 1) ? ((*p & 0xF0) | color) : ((*p & 0x0F) | (color << 4));
}

/*inline int getPixel(int x, int y)
{
  unsigned char* p = (unsigned char*)(SCREEN_BASE_ADDRESS + ((x >> 1) + (y << 7) + (y << 5)));
  return ((x & 1) ? (*p & 0x0F) : (*p >> 4));
}*/

int main(int argc, char **argv)
{
	int intmask = TCT_Local_Control_Interrupts(0);

	clrscr();
	if (lcd_isincolor())
		lcd_ingray();

	rom = fopen("/Documents/nCHIP8/rom.tns", "rb");

	if (rom == 0)
		{
			printf("Failed to open rom image - check if it exists...\n");
			return -1;
		}

	chip = initializeCHIP8();

	fclose(rom);

	do
	{
		//printf("Starting loop\n");
		//printf("PC = 0x%X\n", chip->pc);
		//printf("Opcode = 0x%X\n", chip->opcode);
		//printf("SP = %d", chip->sp);

		emulateCycle(chip);

		//printf("Is drawflag set?\n");

		if (chip->drawflag)
		{
			//printf("true\n");

			for(int row = 0; row < 32; row++)
			{
				for(int col = 0; col < 64; col++)
				{
					for(int rowoffs = 0; rowoffs < 5; rowoffs++){
						for(int coloffs = 0; coloffs < 5; coloffs++){
							setPixel(5*col + coloffs, 5*row + rowoffs, (0x0F * (chip->LCD[64*row + col])) ^ 0x0F);
						}
					}
					//setPixel(col, row, (0x0F * (chip->LCD[64*row + col])) ^ 0x0F);
				}
			}
			chip->drawflag = false;
		}
		//printf("false\nChecking for pressed keys...\n");
		setKeys(chip);
		//printf("Time to start over!\n");
	}while(!isKeyPressed(KEY_NSPIRE_ESC));

	destroy(chip);

	TCT_Local_Control_Interrupts(intmask);

	return 0;
}
